     MODULE ERRORS
       INTERFACE ERRCALC
          MODULE PROCEDURE ERRCALC
       END INTERFACE
       
       CONTAINS 
       SUBROUTINE ERRCALC(EN,XM,XERR)

!	Calculates error on the input vector EN. Just the variance.

        REAL (KIND=8), DIMENSION(:) ::  EN
        REAL (KIND=8)               ::  XM, XERR
 
        NP = SIZE(EN)

        XM  = 0.D0
        XSQ = 0.D0
	DO NT = 1,NP
	   XM  = XM  + EN(NT)
	   XSQ = XSQ + EN(NT)**2
        ENDDO
	XM    = XM /DBLE(NP)
        XSQ   = XSQ/DBLE(NP)
	XERR  = (XSQ - XM**2)/DBLE(NP)
	IF (XERR.GT.0.D0) THEN
           XERR = SQRT(XERR)
	ELSE
	   XERR = 0.D0 
	ENDIF

	RETURN
        END SUBROUTINE ERRCALC
      END MODULE ERRORS

